/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;
import teajay.bytecode.U1;
import teajay.bytecode.cpool.ClassInfo;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class MultiANewArray extends SimpleInstruction {

    public MultiANewArray(ClassInfo type, int dimension) throws ByteCodeException {
        this.setOpcode(OpCode.multianewarray);
        if (dimension <= 255 && dimension >= 1) {
            this.setOperands(type, new U1(dimension));
        } else {
            throw new ByteCodeException("multianewarray: Array dimension out of bounds " + dimension + ".");
        }
    }

    @Override
    int getLocalModifier() {
        return 0;
    }
}
