/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.cpool;

import teajay.bytecode.exceptions.UTFOutOfBoundsException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class StringInfo extends U1U2Entry<Utf8Info> {
    public StringInfo(Utf8Info value) {
        super(CPoolTag.String, value);
    }
    
    public StringInfo(String value) throws UTFOutOfBoundsException {
        super(CPoolTag.String, new Utf8Info(value));
    }
    
    public String getString() {
        return getValue().getValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof StringInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 19 * super.hashCode();
        return hash;
    }
}
