/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.fields;

import teajay.bytecode.AccessFlag;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public enum FieldAccessFlag implements AccessFlag {
    PACKAGE_PRIVATE(0x0000),
    PUBLIC(0x0001),
    PRIVATE(0x0002),
    PROTECTED(0x0004),
    STATIC(0x0008),
    FINAL(0x0010),
    VOLATILE(0x0040),
    TRANSIENT(0x0080),
    SYNTHETIC(0x1000),
    ENUM(0x4000);
    
    public final int intValue;

    private FieldAccessFlag(int value) {
        this.intValue = value;
    }

    @Override
    public int getIntValue() {
        return intValue;
    }
}
