/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class ClosureCreatorNode extends SyntaxNode {

    private final ClosureEnvNode env;
    private final ClosureReturnNode ret;
    private final FormalParametersNode parameters;
    private final BlockNode block;
    private final ArgumentsNode args;

    public ClosureCreatorNode(Symbol s, ClosureEnvNode env,
            ClosureReturnNode ret, FormalParametersNode parameters, BlockNode block,
            ArgumentsNode args) {
        super(s);
        this.env = env;
        this.ret = ret;
        this.parameters = parameters;
        this.block = block;
        this.args = args;
    }
    /**
     * 
     * @return true if closure[exp]<exp>(Type exp){ Statements }(exp); 
     */
    boolean isCall() {
        return args == null ? false : true;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(env, v);
        checkNull(ret, v);
        checkNull(parameters, v);
        checkNull(this.block, v);
        checkNull(args, v);
    }
}
