/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class EnumBodyNode extends SyntaxNode {

    private EnumConstantsNode enumConstants = null;
    private boolean hasComma = false;
    private EnumBodyDeclarationsNode enumBodyDecls = null;

    public EnumBodyNode(Symbol s, EnumConstantsNode enumConstants) {
        super(s);
        this.enumConstants = enumConstants;
    }

    public EnumBodyNode(Symbol s, boolean hasComma) {
        super(s);
        this.hasComma = hasComma;
    }

    public EnumBodyNode(Symbol s, EnumBodyDeclarationsNode enumBodyDecls) {
        super(s);
        this.enumBodyDecls = enumBodyDecls;
    }

    public EnumBodyNode(Symbol s) {
        super(s);
    }

    public EnumBodyNode(Symbol s, EnumConstantsNode enumConstants, boolean hasComma) {
        this.enumConstants = enumConstants;
        this.hasComma = hasComma;
    }

    public EnumBodyNode(Symbol s, EnumConstantsNode enumConstants, boolean hasComma,
            EnumBodyDeclarationsNode enumBodyDecls) {
        super(s);
        this.enumConstants = enumConstants;
        this.hasComma = hasComma;
        this.enumBodyDecls = enumBodyDecls;
    }

    public EnumBodyNode(Symbol s, boolean hasComma,
            EnumBodyDeclarationsNode enumBodyDecls) {
        super(s);
        this.hasComma = hasComma;
        this.enumBodyDecls = enumBodyDecls;
    }

    public boolean hasComma() {
        return this.hasComma;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.enumConstants, v);
        checkNull(this.enumBodyDecls, v);
        visitor.end(this);
    }
}
