/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
//public class ExpressionNode extends SyntaxNode{
//    private class PreOpExp extends SyntaxNode{
//        private PrefixOpNode preOp;
//        private ExpressionNode exp;
//        public  PreOpExp(PrefixOpNode preOp,ExpressionNode exp){
//            this.preOp = preOp;
//            this.exp = exp;
//        }
//
//        @Override
//        public void accept(Visitor visitor) throws CompilerException{
//            checkNull(preOp, visitor);
//            checkNull(exp, visitor);
//        }
//    }
//    private class TypeExp extends SyntaxNode{
//        private TypeNode type;
//        private ExpressionNode exp;
//        public  TypeExp(TypeNode type,ExpressionNode exp){
//            this.type = type;
//            this.exp = exp;
//        }
//
//        @Override
//        public void accept(Visitor visitor) throws CompilerException{
//            checkNull(type, visitor);
//            checkNull(exp, visitor);
//        }
//    }
//    
//    private class PrimaryExpression extends SyntaxNode{
//        private PrimaryNode primary;
//        private LinkedList<SelectorNode> selectorList;
//        private LinkedList<PostfixOpNode> postfixOpList;
//        private Expression2RestNode exp2Rest = null;
//        private Expression1RestNode exp1Rest = null;
//        private AssignmentOperatorNode assignOp = null;
//        private ExpressionNode exp = null;
//        private Expression1RestNode exp1RestAssignOp = null;
//        public PrimaryExpression(PrimaryNode primary,LinkedList<SelectorNode> selectorList,
//                                 LinkedList<PostfixOpNode> postfixOpList, Expression2RestNode exp2Rest,Expression1RestNode exp1Rest){
//            this.primary = primary;
//            this.selectorList = selectorList;
//            this.postfixOpList = postfixOpList;
//            this.exp2Rest = exp2Rest;
//            this.exp1Rest = exp1Rest;    
//        }
//        public PrimaryExpression(PrimaryNode primary,LinkedList<SelectorNode> selectorList,
//                                 LinkedList<PostfixOpNode> postfixOpList, Expression2RestNode exp2Rest,
//                                 Expression1RestNode exp1Rest,AssignmentOperatorNode assignOp,
//                                 ExpressionNode exp, Expression1RestNode exp1RestAssignOp ){
//           this(primary, selectorList, postfixOpList, exp2Rest, exp1Rest);
//           this.assignOp = assignOp;
//           this.exp = exp;
//           this.exp1RestAssignOp = exp1RestAssignOp;
//        }
//
//        @Override
//        public void accept(Visitor visitor) throws CompilerException{
//            checkNull(primary, visitor);
//            if(selectorList != null){
//                for( SelectorNode s: selectorList){
//                    s.accept(visitor);
//                }
//            }
//            if(postfixOpList != null){
//                for(PostfixOpNode op : postfixOpList){
//                    op.accept(visitor);
//                }
//            }
//            checkNull(exp2Rest, visitor);
//            checkNull(exp1Rest, visitor);
//            checkNull(assignOp, visitor);
//            checkNull(exp, visitor);
//            checkNull(exp1RestAssignOp, visitor);
//            
//            
//        }
//    }
//    
//    private PreOpExp preOpExpression = null;
//    private TypeExp typeExpression = null;
//    private PrimaryExpression primaryExpression = null;
//    private ExpressionHelperNode expHelper;
//    
//    public ExpressionNode(PrefixOpNode p, ExpressionNode exp, ExpressionHelperNode expHelper) {
//        this.preOpExpression = new PreOpExp(p, exp);
//        this.expHelper = expHelper;
//    }
//
//    public ExpressionNode(TypeNode t, ExpressionNode exp, ExpressionHelperNode expHelper) {
//        this.typeExpression = new TypeExp(t, exp);
//        this.expHelper = expHelper;
//    }
//
//    public ExpressionNode(PrimaryNode primary, LinkedList<SelectorNode> selectorList,
//            LinkedList<PostfixOpNode> postfixOpList,
//            Expression2RestNode exp2Rest, Expression1RestNode exp1Rest, ExpressionHelperNode expHelper) {
//
//        this.primaryExpression = new PrimaryExpression(primary, selectorList, postfixOpList, exp2Rest, exp1Rest);
//        this.expHelper = expHelper;
//    }
//
//    public ExpressionNode(PrimaryNode primary, LinkedList<SelectorNode> selectorList,
//            LinkedList<PostfixOpNode> postfixOpList, Expression2RestNode exp2Rest,
//            Expression1RestNode exp1Rest, AssignmentOperatorNode assignOp,
//            ExpressionNode exp, Expression1RestNode exp1RestAssignOp, ExpressionHelperNode expHelper) {
//        
//        this.primaryExpression = new PrimaryExpression(primary, selectorList, postfixOpList, 
//                                    exp2Rest, exp1Rest, assignOp, exp, exp1RestAssignOp);
//        this.expHelper = expHelper;
//    }
//    
//    
//    @Override
//    public void accept(Visitor visitor) throws CompilerException{
//        visitor.begin(this);
//        Visitor v = visitor.visit(this);
//        checkNull(this.preOpExpression, v);
//        checkNull(this.primaryExpression, v);
//        checkNull(this.typeExpression,v);
//        checkNull(this.expHelper, v);
//        
//        visitor.end(this);
//        
//    }
//    
//}
public class ExpressionNode extends SyntaxNode {

    private Expression1Node expression1;
    private AssignmentOperatorNode assignmentOp = null;
    private Expression1Node assignmentExpression = null;

    public static enum ExpressionType {

        NEW_EXPRESSION,
        LITERAL,
        ADD_EXPRESSION
    }
    private ExpressionType type;

    public ExpressionNode(Symbol s, Expression1Node expression1) {
        super(s);
        this.expression1 = expression1;
    }

    public ExpressionNode(Expression1Node expression1,
            AssignmentOperatorNode assignmentOp,
            Expression1Node assignmentExpression) {
        this.expression1 = expression1;
        this.assignmentOp = assignmentOp;
        this.assignmentExpression = assignmentExpression;
    }

    public boolean isAssignmentExpression() {
        return this.assignmentExpression == null ? false : true;
    }

    public ExpressionType getExpressionType() {
        return type;
    }

    public void setExpressionType(ExpressionType type) {
        this.type = type;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(expression1, v);
        checkNull(assignmentOp, v);
        checkNull(assignmentExpression, v);
        visitor.end(this);
    }
}
