/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class InfixOpNode extends SyntaxNode {

    public enum InfixOps {

        OR(0),
        AND(0),
        BIT_OR(/*3*/0),
        BIT_AND(/*3*/0),
        BIT_XOR(/*3*/0),
        EQL(1),
        NEQL(1),
        LESS(1),
        GREATER(1),
        LESS_EQUAL(1),
        GREATER_EQUAL(1),
        LEFT_SHIFT(3),
        RIGHT_SHIFT(3),
        DOUBLE_RIGHT_SHIFT(3),
        ADD(2),
        SUB(2),
        MULT(3),
        DIV(3),
        MOD(3);
        final int priority;

        private InfixOps(int priority) {
            this.priority = priority;
        }

        public int getPriority() {
            return this.priority;
        }
    }
    InfixOps operator;

    public InfixOpNode(Symbol s, InfixOps operator) {
        super(s);
        this.operator = operator;
    }

    public InfixOps getOperator() {
        return operator;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        visitor.visit(this);
        visitor.end(this);
    }
}
