/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class InterfaceMemberDeclNode extends SyntaxNode {

    private InterfaceMethodOrFieldDeclNode methodOrField = null;
    private String identifier = null;
    private VoidInterfaceMethodDeclaratorRestNode methodDeclaratorRest = null;
    private InterfaceGenericMethodDeclNode genericMethodDecl = null;
    private ClassDeclarationNode classDeclaration = null;
    private InterfaceDeclarationNode interfaceDeclaration = null;

    public InterfaceMemberDeclNode(Symbol s, InterfaceMethodOrFieldDeclNode methodOrField) {
        this.methodOrField = methodOrField;
    }

    public InterfaceMemberDeclNode(Symbol s, String identifier,
            VoidInterfaceMethodDeclaratorRestNode methodDeclartorRest) {
        super(s);
        this.identifier = identifier;
        this.methodDeclaratorRest = methodDeclartorRest;

    }

    public InterfaceMemberDeclNode(Symbol s, InterfaceGenericMethodDeclNode genericMethodDecl) {
        super(s);
        this.genericMethodDecl = genericMethodDecl;
    }

    public InterfaceMemberDeclNode(Symbol s, ClassDeclarationNode classDeclaration) {
        super(s);
        this.classDeclaration = classDeclaration;
    }

    public InterfaceMemberDeclNode(Symbol s, InterfaceDeclarationNode interfaceDeclaration) {
        super(s);
        this.interfaceDeclaration = interfaceDeclaration;
    }

    public String getIdentifier() {
        return this.identifier;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.methodOrField, v);
        checkNull(this.methodDeclaratorRest, v);
        checkNull(this.genericMethodDecl, v);
        checkNull(this.classDeclaration, v);
        checkNull(this.interfaceDeclaration, v);
        visitor.end(this);
    }
}
