/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class NormalClassDeclarationNode extends SyntaxNode {

    private String className;
    private TypeParametersNode typeParameters; // template definition
    private TypeNode extendsFromType;
    private TypeListNode implementsOfTypes;
    private ClassBodyNode classBody;

    public NormalClassDeclarationNode(Symbol s, String className,
            TypeParametersNode typeParameters,
            TypeNode extendsFromType,
            TypeListNode implementsOfTypes,
            ClassBodyNode classBody) {
        super(s);
        this.className = className;
        this.typeParameters = typeParameters;
        this.extendsFromType = extendsFromType;
        this.implementsOfTypes = implementsOfTypes;
        this.classBody = classBody;

    }

    public String getClassName() {
        return this.className;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.typeParameters, v);
        checkNull(this.extendsFromType, v);
        checkNull(this.implementsOfTypes, v);
        checkNull(this.classBody, v);
        visitor.end(this);
    }
}
