/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;
/**
 *
 * @author Michael Burzan
 */
public class TjTypeDefNode extends SyntaxNode {
    private final List<ModifierNode> modifiers;
    private final String typeName;
    private final TypeParametersNode genericParameters;
    private final TypeNode extendsFrom;
    private final TypeListNode implementsThis;
    private final TjTypeDefBodyNode typeDefBody;

    public TjTypeDefNode(Symbol s, List<ModifierNode> modifiers, String typeName, TypeParametersNode typeParameters,
            TypeNode type, TypeListNode typeList, TjTypeDefBodyNode typeDefBody) {
        super(s);
        this.modifiers = modifiers;
        this.typeName = typeName;
        this.genericParameters = typeParameters;
        this.extendsFrom = type;
        this.implementsThis = typeList;
        this.typeDefBody = typeDefBody;
        
    }

    public String getIdentifier() {
        return this.typeName;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.modifiers, v);
        checkNull(this.genericParameters, v);
        checkNull(this.extendsFrom, v);
        checkNull(this.implementsThis, v);
        checkNull(this.typeDefBody, v);
        visitor.end(this);
    }
}
