/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.ClosureEnvNode;
import abstractsyntaxtree.ClosureReturnNode;
import abstractsyntaxtree.FormalParametersNode;
import codegeneration.Visitor;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractClosureCreatorVisitor extends Visitor {

    public abstract void begin(ClosureEnvNode node) throws exceptions.CompilerException;

    public abstract void begin(ClosureReturnNode node) throws exceptions.CompilerException;

    public abstract void begin(FormalParametersNode node) throws exceptions.CompilerException;

    public abstract void begin(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClosureEnvNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClosureReturnNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(FormalParametersNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(ClosureEnvNode node) throws exceptions.CompilerException;

    public abstract void end(ClosureReturnNode node) throws exceptions.CompilerException;

    public abstract void end(FormalParametersNode node) throws exceptions.CompilerException;

    public abstract void end(ArgumentsNode node) throws exceptions.CompilerException;
    
    public abstract void begin(BlockNode node) throws CompilerException;
    public abstract Visitor visit(BlockNode node) throws CompilerException;
    public abstract void end(BlockNode node) throws CompilerException;
}
