/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.BasicTypeNode;
import abstractsyntaxtree.ClosureCreatorNode;
import abstractsyntaxtree.CreatorNode;
import abstractsyntaxtree.ExplicitGenericInvocationSuffixNode;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.IdentifierSuffixNode;
import abstractsyntaxtree.LiteralNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import abstractsyntaxtree.ParExpressionNode;
import abstractsyntaxtree.SuperSuffixNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractPrimaryVisitor extends Visitor {

    public abstract void begin(LiteralNode node) throws exceptions.CompilerException;

    public abstract void begin(TypeNode node) throws exceptions.CompilerException;

    public abstract void begin(ParExpressionNode node) throws exceptions.CompilerException;

    public abstract void begin(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract void begin(SuperSuffixNode node) throws exceptions.CompilerException;

    public abstract void begin(CreatorNode node) throws exceptions.CompilerException;

    public abstract void begin(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void begin(ExplicitGenericInvocationSuffixNode node) throws exceptions.CompilerException;

    public abstract void begin(IdentifierSuffixNode node) throws exceptions.CompilerException;

    public abstract void begin(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract void begin(ClosureCreatorNode node) throws exceptions.CompilerException;

    public abstract void begin(ExpressionNode node) throws exceptions.CompilerException;

    public abstract void visit(LiteralNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ParExpressionNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(SuperSuffixNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(CreatorNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ExplicitGenericInvocationSuffixNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(IdentifierSuffixNode node) throws exceptions.CompilerException;

    public abstract void visit(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClosureCreatorNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ExpressionNode node) throws exceptions.CompilerException;

    public abstract void end(LiteralNode node) throws exceptions.CompilerException;

    public abstract void end(TypeNode node) throws exceptions.CompilerException;

    public abstract void end(ParExpressionNode node) throws exceptions.CompilerException;

    public abstract void end(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(SuperSuffixNode node) throws exceptions.CompilerException;

    public abstract void end(CreatorNode node) throws exceptions.CompilerException;

    public abstract void end(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(ExplicitGenericInvocationSuffixNode node) throws exceptions.CompilerException;

    public abstract void end(IdentifierSuffixNode node) throws exceptions.CompilerException;

    public abstract void end(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract void end(ClosureCreatorNode node) throws exceptions.CompilerException;

    public abstract void end(ExpressionNode node) throws exceptions.CompilerException;
}
