/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.BasicTypeNode;
import abstractsyntaxtree.ClosureTypeDecNode;
import abstractsyntaxtree.EdgeClampsOpenCloseHelperNode;
import abstractsyntaxtree.ReferenceTypeNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractTypeVisitor extends Visitor {

    public abstract void begin(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract void visit(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract void end(BasicTypeNode node) throws exceptions.CompilerException;

    public abstract void begin(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract void end(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract void begin(EdgeClampsOpenCloseHelperNode node) throws exceptions.CompilerException;

    public abstract void visit(EdgeClampsOpenCloseHelperNode node) throws exceptions.CompilerException;

    public abstract void end(EdgeClampsOpenCloseHelperNode node) throws exceptions.CompilerException;

    public abstract void begin(ClosureTypeDecNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClosureTypeDecNode node) throws exceptions.CompilerException;

    public abstract void end(ClosureTypeDecNode node) throws exceptions.CompilerException;

    public abstract String getTypeName() throws exceptions.CompilerException;
}
