/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.ClassOrInterfaceDeclaratioNode;
import abstractsyntaxtree.LocalVariableDeclarationsStatementNode;
import abstractsyntaxtree.StatementNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractBlockStatementVisitor;
import codegeneration.javavisitor.statement.StatementVisitor;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.Label;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class BlockStatementVisitor extends AbstractBlockStatementVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;
    private StatementVisitor statementVisitor;
    private Label label;

    BlockStatementVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
    }

    @Override
    public void begin(LocalVariableDeclarationsStatementNode node) {
    }

    @Override
    public void begin(ClassOrInterfaceDeclaratioNode node) {
    }

    @Override
    public void begin(StatementNode node) {
    }

    @Override
    public Visitor visit(LocalVariableDeclarationsStatementNode node) {
        return new LocalVariableDeclarationsStatementVisitor(this.classFile, this.info);

    }

    @Override
    public Visitor visit(ClassOrInterfaceDeclaratioNode node) {
        return null;
    }

    @Override
    public Visitor visit(StatementNode node) {
        if (label != null) {
            this.statementVisitor = new StatementVisitor(this.classFile, this.info, label);
            label = null;
            return this.statementVisitor;
        } else {
            return this.statementVisitor = new StatementVisitor(this.classFile, this.info);
        }

    }

    @Override
    public void end(LocalVariableDeclarationsStatementNode node) {
    }

    @Override
    public void end(ClassOrInterfaceDeclaratioNode node) {
    }

    @Override
    public void end(StatementNode node) {
        this.label = statementVisitor.getLabel();
    }
}
