/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package codegeneration.javavisitor;

import abstractsyntaxtree.QualifiedIdentifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractQualifiedIdentifierListVisitor;
import codegeneration.abstractvisitors.AbstractQualifiedIdentifierVisitor;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author cefour
 */
public class QualifiedIdentifierListVisitor extends AbstractQualifiedIdentifierListVisitor {

    private AbstractQualifiedIdentifierVisitor qualifiedIdentifierVisitor;
    private ArrayList<String> list = new ArrayList<>();

    @Override
    public void begin(QualifiedIdentifierNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(QualifiedIdentifierNode node) throws CompilerException {
        return this.qualifiedIdentifierVisitor = new QualifiedIdentifierVisitor();
    }

    @Override
    public void end(QualifiedIdentifierNode node) throws CompilerException {
        Iterator<String> iter = qualifiedIdentifierVisitor.getQualifiedNameList().iterator();
        StringBuilder builder = new StringBuilder();
        while (iter.hasNext()) {
            builder.append(iter.next());
            if (iter.hasNext()) {
                builder.append("/");
            }
        }
        this.list.add(builder.toString());
    }

    @Override
    public List<String> getQualifiedIdentifiers() {
        return this.list;
    }
}
