/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.VariableDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVariableDeclaratorVisitor;
import exceptions.CompilerException;
import java.util.logging.Level;
import java.util.logging.Logger;
import symbol.LocalTable;
import symbol.SymbolFacade;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class VariableDeclaratorVisitor extends AbstractVariableDeclaratorVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;
    private final String varName;
    private final String typeName;

    public VariableDeclaratorVisitor(ClassFile classFile, MethodInfo info, String varName, String typeName) {
        this.classFile = classFile;
        this.info = info;
        this.varName = varName;
        this.typeName = typeName;
    }

    @Override
    public void begin(VariableDeclaratorRestNode node) {
        /*LocalTable table = null;//SymbolFacade.instance().getLocalTable();
        try {
            table.addEntry(varName, typeName, null);
        } catch (CompilerException ex) {
            ex.printStackTrace(System.err);
        }*/

    }

    @Override
    public Visitor visit(VariableDeclaratorRestNode node) {
        return new VariableDeclaratorRestVisitor(this.classFile, this.info, this.varName, this.typeName);
    }

    @Override
    public void end(VariableDeclaratorRestNode node) {
    }
}
