/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import abstractsyntaxtree.Expression2RestNode;
import abstractsyntaxtree.Expression2RestNode.InfixOpExpression3Node;
import abstractsyntaxtree.Expression3Node;
import abstractsyntaxtree.InfixOpNode;
import abstractsyntaxtree.PrimaryNode;
import codegeneration.Visitor;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author cefour
 */
public class ExpressionTransformer {

    /*private final ExpressionNode node;
     private final List<JVMInstruction> instructionList;
     private Deque<JVMInstruction> itemStack = new LinkedList<>();
     private Deque<InfixOpNode.InfixOps> operatorStack = new LinkedList<>();

     public ExpressionTransformer(){
     node = null;
     instructionList = null;
     }
    
     public ExpressionTransformer(ExpressionNode node) {
     this.node = node;
     this.instructionList = new LinkedList<>();
     }
     public void makeInstructions()throws CompilerException{
     makeInstructionList();
     }
    
     public String getExpressionResultType(){
     return "int";
     }
    
     private void makeInstructionList()throws CompilerException {

     IsCompositeExpressionVisitor isComposite = new IsCompositeExpressionVisitor();
     node.accept(isComposite);
     if (isComposite.hasCompositeExpression) {
     if (isComposite.isCompositeExpression) {
     InfixExpressionCollectorVistor collector = new InfixExpressionCollectorVistor();
     node.accept(collector);
     List<Expression2RestNode.InfixOpExpression3Node> infixList = collector.infixList;
     PrimaryExpVisitor pVisit = new PrimaryExpVisitor();
     node.accept(pVisit);
     if (pVisit.node != null) {
     PrimaryType primaryType = pVisit.node.getPrimaryType();
     switch (primaryType) {
     case NEW_TYPE:
     break;
     case LITERAL_TYPE:
     pushLiteralItem(pVisit.node);
     break;
     case PARANTHISIS_TYPE:
     break;
     default:
     throw new AssertionError(primaryType.name());

     }
     InfixVisitor infixVisitor = new InfixVisitor();

     for(InfixOpExpression3Node infix : collector.infixList) {
     infix.accept(infixVisitor);
     switch (infixVisitor.operator) {
     case OR:
     break;
     case AND:
     break;
     case BIT_OR:
     break;
     case BIT_AND:
     break;
     case BIT_XOR:
     break;
     case EQL:
     break;
     case NEQL:
     break;
     case LESS:
     break;
     case GREATER:
     break;
     case LESS_EQUAL:
     break;
     case GREATER_EQUAL:
     break;
     case LEFT_SHIFT:
     break;
     case RIGHT_SHIFT:
     break;
     case DOUBLE_RIGHT_SHIFT:
     break;
     case ADD:
     this.operatorStack.push(infixVisitor.operator);
     this.pushLiteralItem(infixVisitor.exp.getPrimaryNode());
     break;
     case SUB:
     break;
     case MULT:
     this.operatorStack.push(infixVisitor.operator);
     insertInstructions(infixVisitor.exp);
     break;
     case DIV:
     break;
     case MOD:
     break;
     default:
     throw new AssertionError(infixVisitor.operator.name());

     }
                        
     }
     while (!operatorStack.isEmpty()) {
     insertInstructions();
     }
     }


     } else {//InstanceOf
     }
     }
     }

     public List<JVMInstruction> getInstructionList() {
     return this.instructionList;
     }

     private void pushLiteralItem(PrimaryNode node) {
     class LiteralVistor extends Visitor {

     public LiteralNode.LiteralType literalType;
     public String literalValue;

     public void begin(LiteralNode node) {
     this.literalType = node.getLiteralType();
     this.literalValue = node.getLiteralValue();
     }
     };
     LiteralVistor literal = new LiteralVistor();
     node.accept(literal);



     switch (literal.literalType) {
     case BOOLEAN:
     break;
     case INT: {
     JVMInstruction instr;
     int val = Integer.valueOf(literal.literalValue);
     System.err.println("VAL:"+val);
     if (val <= Short.MAX_VALUE && val >= Short.MIN_VALUE) {
     try {
     instr = new IConst(val);
     } catch (ByteCodeException ex) {
     ex.printStackTrace(System.err);
     System.exit(-1);
     return;
     }
     } else {
     instr = new Ldc(val);
     }

     this.itemStack.push(instr);
     }
     break;
     case LONG:
     break;
     case FLOAT:
     break;
     case DOUBLE:
     break;
     case CHAR:
     break;
     case STRING:
     break;
     case NULL:
     break;
     default:
     throw new AssertionError(literal.literalType.name());

     }
     }

     private void insertInstructions(Expression3Node exp) {
     if (exp != null) {
     pushLiteralItem(exp.getPrimaryNode());
     }


     switch (this.operatorStack.pop()) {
     case OR:
     break;
     case AND:
     break;
     case BIT_OR:
     break;
     case BIT_AND:
     break;
     case BIT_XOR:
     break;
     case EQL:
     break;
     case NEQL:
     break;
     case LESS:
     break;
     case GREATER:
     break;
     case LESS_EQUAL:
     break;
     case GREATER_EQUAL:
     break;
     case LEFT_SHIFT:
     break;
     case RIGHT_SHIFT:
     break;
     case DOUBLE_RIGHT_SHIFT:
     break;
     case ADD:{
     if(!this.itemStack.isEmpty())
     this.instructionList.add(this.itemStack.pop());
     if(!this.itemStack.isEmpty())
     this.instructionList.add(this.itemStack.pop());
     this.instructionList.add(new IAdd());
     }
     break;
     case SUB:
     break;
     case MULT:{
     if(!this.itemStack.isEmpty())
     this.instructionList.add(this.itemStack.pop());
     if(!this.itemStack.isEmpty())
     this.instructionList.add(this.itemStack.pop());
     this.instructionList.add(new IMul());
     }
     break;
     case DIV:
     break;
     case MOD:
     break;
     default:
     throw new AssertionError(this.operatorStack.pop().name());

     }
     }

     private void insertInstructions() {
     insertInstructions(null);
     }*/
}

class InfixVisitor extends Visitor {

    public InfixOpNode.InfixOps operator;
    public Expression3Node exp;

    public void begin(InfixOpNode node) {
        this.operator = node.getOperator();
    }

    public void begin(Expression3Node node) {
        this.exp = node;
    }

    public Visitor visit(Expression3Node node) {
        return null;
    }
}

class PrimaryExpVisitor extends Visitor {

    public PrimaryNode node;

    public void begin(Expression3Node node) {
        if (node.isPrimary()) {
            this.node = node.getPrimaryNode();
        } else {
            node = null;
        }
    }

    public Visitor visit(Expression3Node node) {
        return null;
    }
}
/*
 class VariableCreatorVisitor extends Visitor {

 private final ClassFile file;
 private final MethodInfo info;
 private final String varName;
 private final String typeName;
 private LiteralNode.LiteralType literalType;
 private List<String> parametersType = new LinkedList<>();

 public VariableCreatorVisitor(ClassFile file, MethodInfo info, String varName, String typeName) {
 this.file = file;
 this.info = info;
 this.varName = varName;
 this.typeName = typeName;
 }

 public Visitor visit(CreatorNode node) {

 return this;
 }

 public void begin(CreatedNameNode node) {
 String ident = node.getIdentifier();
 ident = SymbolFacade.instance().getFullQualifiedId(ident);
 try {
 if (ident == null) {
 throw new CompilerException("new expected type", node.getSymbol());
 }
 if (this.typeName.equals(ident) || SymbolFacade.instance().isDerivated(this.typeName, ident)) {
 JVMInstructionList instructionList = this.info.getCode().getInstructionList();
 instructionList.add(new New(new ClassInfo(this.typeName)));
 instructionList.add(new Dup());
 } else {
 throw new CompilerException("Incompatible type found:" + ident + " required: " + this.typeName, node.getSymbol());
 }
 } catch (ByteCodeException ex) {
 ex.printStackTrace(System.err);
 } catch (CompilerException ex) {
 ex.printStackTrace(System.err);
 System.exit(-1);
 }
 }

 public void end(CreatorNode node) {
 try {
 JVMInstructionList instructionList = this.info.getCode().getInstructionList();
 MethodRefInfo ref = InstructionCreator.CreateConstructor(typeName,
 parametersType.toArray(new String[1]));


 instructionList.add(new InvokeSpecial(ref));

 LocalEntry entry = SymbolFacade.instance().getLocalTable().getEntry(varName);

 instructionList.add(new AStore(entry.getIndex()));

 } catch (ByteCodeException ex) {
 ex.printStackTrace(System.err);
 }

 }

 public void begin(LiteralNode node) {
 this.literalType = node.getLiteralType();
 String literalValue = node.getLiteralValue();
 JVMInstructionList instructionList = this.info.getCode().getInstructionList();
 try {
 switch (literalType) {
 case BOOLEAN:
 break;
 case INT:
 parametersType.add("int");
 instructionList.pushInt(Integer.valueOf(literalValue));
 break;
 case LONG:
 break;
 case FLOAT:
 break;
 case DOUBLE:
 break;
 case CHAR:
 break;
 case STRING:
 parametersType.add("java/lang/String");
 instructionList.add(new Ldc(literalValue));
 break;
 case NULL:
 break;
 default:
 throw new AssertionError(literalType.name());

 }
 } catch (ByteCodeException ex) {
 }
 }
 }
 */

class InfixExpressionCollectorVistor extends Visitor {

    public List<InfixOpExpression3Node> infixList = new LinkedList<>();

    public Visitor visit(Expression2RestNode node) {
        List<InfixOpExpression3Node> ilist = node.getInfixList();
        if (ilist != null) {
            infixList.add(ilist.get(0));
        }
        return this;
    }
}