/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.method;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.ModifierNode.Modifier;
import abstractsyntaxtree.VoidMethodeDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVoidMethodeDeclaratorRestHelperVisitor;
import codegeneration.abstractvisitors.AbstractVoidMethodeDeclaratorRestVisitor;
import java.util.List;
import teajay.bytecode.ClassFile;

/**
 *
 * @author cefour
 */
public class VoidMethodeDeclaratorRestHelperVisitor extends AbstractVoidMethodeDeclaratorRestHelperVisitor {

    private final ClassFile classFile;
    private List<ModifierNode> modis = null;
    private AbstractVoidMethodeDeclaratorRestVisitor voidMethodeDeclaratorRestVisitor;
    private final String methodName;

    public VoidMethodeDeclaratorRestHelperVisitor(ClassFile classFile, List<ModifierNode> modis, String methodName) {
        this.classFile = classFile;
        this.modis = modis;
        this.methodName = methodName;
    }

    public VoidMethodeDeclaratorRestHelperVisitor(ClassFile classFile, String methodName) {
        this.classFile = classFile;
        this.methodName = methodName;
    }

    @Override
    public void begin(VoidMethodeDeclaratorRestNode node) {
        if (modis != null) {
            this.voidMethodeDeclaratorRestVisitor = new VoidMethodeDeclaratorRestVisitor(classFile, modis, methodName);
        } else {
            this.voidMethodeDeclaratorRestVisitor = new VoidMethodeDeclaratorRestVisitor(classFile, methodName);
        }
    }

    @Override
    public Visitor visit(VoidMethodeDeclaratorRestNode node) {
        return this.voidMethodeDeclaratorRestVisitor;
    }

    @Override
    public void end(VoidMethodeDeclaratorRestNode node) {
    }
}
