/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.statement;

import abstractsyntaxtree.ExpressionNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractStatementExpressionVisitor;
import codegeneration.javavisitor.expression.ExpressionVisitor;
import codegeneration.javavisitor.expression.expressiontransform.ExpressionTransformer;
import codegeneration.javavisitor.expression.expressiontransform.StatementExpressionCreator;
import exceptions.CompilerException;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.Label;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class StatementExpressionVisitor extends AbstractStatementExpressionVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;
    private final Label label;

    StatementExpressionVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
        this.label = null;
    }

    StatementExpressionVisitor(ClassFile classFile, MethodInfo info, Label label) {
        this.classFile = classFile;
        this.info = info;
        this.label = label;
    }

    @Override
    public void begin(ExpressionNode node) throws CompilerException{
        StatementExpressionCreator creator = new StatementExpressionCreator(this.classFile, this.info, node, label);
        creator.makeInstructions();
    }

    @Override
    public Visitor visit(ExpressionNode node) {

        return null;//new ExpressionVisitor(this.classFile,this.info);
    }

    @Override
    public void end(ExpressionNode node) {
    }
}
