/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package exceptions;

import lexer.Symbol;
import minicompiler.CompileManager;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class CompilerException extends Exception {

    private final String errorMessage;
    private final Symbol symbol;

    public CompilerException(String errorMessage, Symbol s) {
        //super(errorMessage + " in line "+ (s.line));

        super("" + CompileManager.instance().getCurrentFilename() + ":" + (s.line + 1) + ": " + errorMessage + (s.column > 0 ? " near column " + s.column : ""));
        this.errorMessage = errorMessage;
        this.symbol = s;
    }
    public CompilerException(Type t, String msg,Symbol s ) {
        
        this(msg + " by " + t,s);
        
    }
    
    

    public CompilerException(String errorMessage) {
        super(errorMessage);
        this.errorMessage = errorMessage;
        this.symbol = null;
    }

    public int getLine() {
        return symbol.line;
    }

    public String getErrorMessage() {
        return this.errorMessage;
    }
}
