/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.ArrayCreatorRestNode;
import abstractsyntaxtree.ClassCreatorRestNode;
import abstractsyntaxtree.CreatedNameNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractCreatorVisitor;
import codegeneration.environment.Stage0Environment;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.Iterator;
import minicompiler.WorkingNode;
import symbol.SymbolFacade;
import teajay.util.QIDTools;
import teajay.util.io.Input;
import teajay.util.io.TJSourceFinder;

/**
 *
 * @author Michael Burzan
 *
 * expression:= new MyString().run(); possible the createdname represents a typename 
 * 
 */
public class Stage1CreatorVisitor extends AbstractCreatorVisitor {

    private final Stage1Environment stage1Env;
    private Stage1CreatedNameVisitor createdNameVisitor;

    public Stage1CreatorVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(NonWildcardTypeArgumentsNode node) throws CompilerException {
    }

    @Override
    public void begin(CreatedNameNode node) throws CompilerException {
    }

    @Override
    public void begin(ClassCreatorRestNode node) throws CompilerException {
    }

    @Override
    public void begin(ArrayCreatorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(NonWildcardTypeArgumentsNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(CreatedNameNode node) throws CompilerException {
        return createdNameVisitor = new Stage1CreatedNameVisitor(stage1Env, node.getIdentifier());
    }

    @Override
    public Visitor visit(ClassCreatorRestNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(ArrayCreatorRestNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(NonWildcardTypeArgumentsNode node) throws CompilerException {
    }
    
    @Override
    public void end(CreatedNameNode node) throws CompilerException {

        StringBuilder builder = new StringBuilder();
        Iterator<String> iter = this.createdNameVisitor.getIdentList().iterator();
        while (iter.hasNext()) {
            builder.append(iter.next());
            if (iter.hasNext()) {
                builder.append("/");
            }
        }
        String importName = builder.toString();
        Stage0Environment stage0Env = stage1Env.getEnv();
        SymbolFacade facade = stage0Env.getSymbolFacade();
        
        String qID = facade.getFullQualifiedId(importName);
        if (qID == null) {
            String packageName = QIDTools.packageName(this.stage1Env.getEnv().getClassFile().getThis().getClassName());
            TJSourceFinder finder = TJSourceFinder.instance();
            if (packageName == null) {
                packageName = "";
            }
            Input find = finder.find(packageName + "/" + importName);
            if (find == null) {
                throw new CompilerException("Type " + packageName + "/" + importName + " not found", node.getSymbol());
            }
            stage1Env.addWorkingNode(new WorkingNode(stage1Env.getFacade(), packageName + "/" + importName, find));

        }
        node.setIdentifier(importName);

    }

    @Override
    public void end(ClassCreatorRestNode node) throws CompilerException {
    }

    @Override
    public void end(ArrayCreatorRestNode node) throws CompilerException {
    }
}
