/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.ClassBodyNode;
import abstractsyntaxtree.TypeListNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractNormalClassDeclarationVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;

/**
 *
 * @author Michael Burzan
 */
class Stage1NormalClassDeclartionVisitor extends AbstractNormalClassDeclarationVisitor {
    private final Stage1Environment stage1Env;

    public Stage1NormalClassDeclartionVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
 
    }

    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        return new Stage1GenericTypeParametersVisitor(stage1Env);
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {
 
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
 
    }

    @Override
    public void begin(TypeListNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeListNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public void end(TypeListNode node) throws CompilerException {
 
    }

    @Override
    public void begin(ClassBodyNode node) throws CompilerException {
 
    }

    @Override
    public Visitor visit(ClassBodyNode node) throws CompilerException {
        return new Stage1ClassBodyVisitor(stage1Env);
    }

    @Override
    public void end(ClassBodyNode node) throws CompilerException {
 
    }
    
}
