/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.InterfaceGenericMethodDeclNode;
import abstractsyntaxtree.InterfaceMethodDeclaratorRestNode;
import abstractsyntaxtree.TjTypeDefConstructorDeclNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.VoidInterfaceMethodDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTjTypeDefMemberDeclVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;

/**
 *
 * @author Michael Burzan
 */
class Stage1TjTypeDefMemberDeclVisitor extends AbstractTjTypeDefMemberDeclVisitor {
    private final Stage1Environment stage1Env;

    public Stage1TjTypeDefMemberDeclVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
 
    }

    @Override
    public void begin(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
 
    }

    @Override
    public void begin(TjTypeDefConstructorDeclNode node) throws CompilerException {
 
    }

    @Override
    public void begin(InterfaceGenericMethodDeclNode node) throws CompilerException {
 
    }

    @Override
    public void begin(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public Visitor visit(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public Visitor visit(TjTypeDefConstructorDeclNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public Visitor visit(InterfaceGenericMethodDeclNode node) throws CompilerException {
        return new Stage1GenericInterfaceMethodDeclVisitor(stage1Env);
    }

    @Override
    public Visitor visit(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
 
    }

    @Override
    public void end(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
 
    }

    @Override
    public void end(TjTypeDefConstructorDeclNode node) throws CompilerException {
 
    }

    @Override
    public void end(InterfaceGenericMethodDeclNode node) throws CompilerException {
        stage1Env.dropGenericMethodContext();
    }

    @Override
    public void end(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
 
    }
    
}
