/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TjTypeDefBodyNode;
import abstractsyntaxtree.TypeListNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTjTypeDefVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage1TjTypeDefVisitor extends AbstractTjTypeDefVisitor {

    private final Stage1Environment stage1Env;
    private List<Type.TypeParamType> typeParamTypes = new ArrayList<>();
    private Type.ClassType classType;

    Stage1TjTypeDefVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(TypeParametersNode node)throws CompilerException {
    }

    @Override
    public void begin(TypeNode node)throws CompilerException {
    }

    @Override
    public void begin(TypeListNode node)throws CompilerException {
    }

    @Override
    public void begin(TjTypeDefBodyNode node)throws CompilerException {
    }

    @Override
    public Visitor visit(TypeParametersNode node)throws CompilerException { // generic

        return new Stage1GenericTypeParametersVisitor(stage1Env);
    }

    @Override
    public Visitor visit(TypeNode node)throws CompilerException { //extends
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public Visitor visit(TypeListNode node)throws CompilerException {
        return new Stage1TypeVisitor(stage1Env, new ArrayList<String>());
    }

    @Override
    public Visitor visit(TjTypeDefBodyNode node)throws CompilerException {
        return new Stage1TjTypeDefBodyVisitor(stage1Env);
    }

    @Override
    public void end(TypeParametersNode node)throws CompilerException {
    }

    @Override
    public void end(TypeNode node)throws CompilerException {
    }

    @Override
    public void end(TypeListNode node)throws CompilerException { //implements
    }

    @Override
    public void end(TjTypeDefBodyNode node)throws CompilerException {
    }

    @Override
    public void begin(ModifierNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(ModifierNode node) throws CompilerException {
    }
}
//    return new AbstractTypeParameterVisitor() {
//             private Stage1ReferenceTypeVisitor refVisitor;
//             @Override
//             public void begin(BoundNode node)throws CompilerException {
//             }
//
//             @Override
//             public Visitor visit(BoundNode node)throws CompilerException {
//                 return new AbstractBoundVisitor() {
//
//
//                     @Override
//                     public void begin(ReferenceTypeNode node)throws CompilerException {
//
//                     }
//
//                     @Override
//                     public Visitor visit(ReferenceTypeNode node)throws CompilerException {
//                         refVisitor = new Stage1ReferenceTypeVisitor(stage1Env,node.getName());
//                         return refVisitor;
//                     }
//
//                     @Override
//                     public void end(ReferenceTypeNode node)throws CompilerException {
//                           String typeName = node.getName();
//                           //hier noch von ref alles sammeln
//                           String fullQualifiedId = stage1Env.getFacade().getFullQualifiedId(typeName);
//                          // classType = new Type.ClassType(null, fullQualifiedId,refVisitor.getTypes());
//
//                     }
//                 };
//             }
//
//             @Override
//             public void end(BoundNode node)throws CompilerException {
//             }
//         };
//     }
//
//     @Override
//     public void end(TypeParameterNode node)throws CompilerException {
//        // Type.ClassSigType sigType = new Type.ClassSigType(null, sigType, null);
//     }
// };
