/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.ClassOrInterfaceDeclaratioNode;
import abstractsyntaxtree.TjImplDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeDeclarationVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage1TypeDeclarationVisitor extends AbstractTypeDeclarationVisitor {
    private final Stage1Environment stage1Env;

    public Stage1TypeDeclarationVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
        return new Stage1ClassOrInterfaceDeclarationVisitor(stage1Env);
    }

    @Override
    public void end(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
        
    }

    @Override
    public void begin(TjImplDeclarationNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TjImplDeclarationNode node) throws CompilerException {
        return new Stage1TjImplDeclarationVisitor(stage1Env);
    }

    @Override
    public void end(TjImplDeclarationNode node) throws CompilerException {
        
    }
    
}
