/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.TypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractDotIdentifierTypeArgumentsHelperVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2DotIdentifierTypeArgumentsHelperVisitor extends AbstractDotIdentifierTypeArgumentsHelperVisitor {
    private final Stage2Environment stage2Env;
    private Stage2TypeArgumentsVisitor stage2TypeArguments;


    Stage2DotIdentifierTypeArgumentsHelperVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
 
    }

    @Override
    public void begin(TypeArgumentsNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(TypeArgumentsNode node) throws CompilerException {
        return stage2TypeArguments = new Stage2TypeArgumentsVisitor(stage2Env);
    }

    @Override
    public void end(TypeArgumentsNode node) throws CompilerException {

    }
    /**
     * 
     * @return a List of generic types, don't exist generic type the list is empty
     */
    public List<Type> getTypeArguments(){
        if (stage2TypeArguments != null) {
            return stage2TypeArguments.getTypes();
        } else {
            return Collections.emptyList();
        }
    }
    
}
