/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package stage2;

import abstractsyntaxtree.EnumBodyDeclarationsNode;
import abstractsyntaxtree.EnumConstantNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractEnumBodyVisitor;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Michael (Burzan | Kußmann)
 */
public class Stage2EnumBodyVisitor extends AbstractEnumBodyVisitor<List<String>> {

    private final List<String> constantNames = new ArrayList<>();

    

    Stage2EnumBodyVisitor() {
    }

    @Override
    public void begin(EnumConstantNode node) {
        constantNames.add(node.getIdentifier());
    }

    @Override
    public void begin(EnumBodyDeclarationsNode node) {
    }

    @Override
    public Visitor visit(EnumConstantNode node) {
        return new Stage2EnumConstantVisitor();
    }

    @Override
    public Visitor visit(EnumBodyDeclarationsNode node) {
        return null;
    }

    @Override
    public void end(EnumConstantNode node) {
    }

    @Override
    public void end(EnumBodyDeclarationsNode node) {
    }

    @Override
    public List<String> getContainer() {
        return this.constantNames;
    }
}
