/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.FormalParameterDeclsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFormalParametersVisitor;
import codegeneration.environment.Stage2Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class Stage2FormalParametersVisitor extends AbstractFormalParametersVisitor< List<Pair<Type,String>>>{
    private final Stage2Environment stage2Env;
    private List<Pair<Type,String>> formalParameterList = new ArrayList<>();
    private Stage2FormalParameterDeclsVisitor formalParameterDecls;

    public Stage2FormalParametersVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(FormalParameterDeclsNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(FormalParameterDeclsNode node) throws CompilerException {
        
       return formalParameterDecls = new Stage2FormalParameterDeclsVisitor(stage2Env,formalParameterList);
    }

    @Override
    public void end(FormalParameterDeclsNode node) throws CompilerException {
        // reverse list because the last parameter, is the first that will be visited
        Collections.reverse(formalParameterList);
    }

    @Override
    public  List<Pair<Type,String>> getFieldContainer() throws CompilerException {
        return formalParameterList;
    }
    
}
