/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.InterfaceMethodOrFieldRestNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractInterfaceMethodOrFieldDeclVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import teajay.bytecode.methods.MethodAccessFlag;

/**
 *
 * @author Michael Burzan
 */
class Stage2InterfaceMethodOrFieldDeclVisitor extends AbstractInterfaceMethodOrFieldDeclVisitor {
    private final MethodAccessFlag[] methodAccessFlags;
    private final String methodName;
    private final Stage2Environment stage2Env;
    private Stage2TypeVisitor stage2Type;

    public Stage2InterfaceMethodOrFieldDeclVisitor(Stage2Environment stage2Env, String methodName, MethodAccessFlag... methodAccessFlag) {
        this.stage2Env = stage2Env;
        this.methodName = methodName;
        this.methodAccessFlags = methodAccessFlag;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {

    }

    @Override
    public void begin(InterfaceMethodOrFieldRestNode node) throws CompilerException {
        

    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return stage2Type = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public Visitor visit(InterfaceMethodOrFieldRestNode node) throws CompilerException {
        return new Stage2InterfaceMethodOrFieldRestVisitor(stage2Env,methodName,methodAccessFlags,stage2Type.getType());
    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(InterfaceMethodOrFieldRestNode node) throws CompilerException {

    }
    
}
