/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.VoidMethodeDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVoidMethodeDeclaratorRestHelperVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.List;
import stage2.utils.MethodHeadBuilder;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjImplVoidMethodDeclaratorRestHelperVistor extends AbstractVoidMethodeDeclaratorRestHelperVisitor {

    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> flagList;
    private final String methodName;
    private Stage2MethodHeadVisitor stage2VoidMethodDeclaratorRestVisitor;
    private final Type.SimpleType type;

    public Stage2TjImplVoidMethodDeclaratorRestHelperVistor(Stage2Environment stage2Env, List<ModifierNode.Modifier> flagList, String methodName) {
        this.stage2Env = stage2Env;
        this.flagList = flagList;
        this.methodName = methodName;
        this.type = new Type.SimpleType("void");
    }

    @Override
    public void begin(VoidMethodeDeclaratorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(VoidMethodeDeclaratorRestNode node) throws CompilerException {
        return stage2VoidMethodDeclaratorRestVisitor = new Stage2MethodHeadVisitor(stage2Env);
    }

    @Override
    public void end(VoidMethodeDeclaratorRestNode node) throws CompilerException {

        MethodHeadBuilder.buildMethodHeadTypeImpl(node, stage2Env,
                type, methodName,
                stage2VoidMethodDeclaratorRestVisitor.getMethodHead(),
                flagList);

    }
}
