/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ClosureTypeFormalParamNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureTypeDecVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClosureTypeDecVisitor extends AbstractClosureTypeDecVisitor {
    private final Stage3Environment stage3Env;
    private Stage3TypeVisitor typeVisitor;
    private List<Type> formalParam = new ArrayList<>();
    private Stage3ClosureTypeFormalParamVisitor formalParamVisitor;

    public Stage3ClosureTypeDecVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public void begin(ClosureTypeFormalParamNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public Visitor visit(ClosureTypeFormalParamNode node) throws CompilerException {
        return formalParamVisitor = new Stage3ClosureTypeFormalParamVisitor(stage3Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
    }

    @Override
    public void end(ClosureTypeFormalParamNode node) throws CompilerException {
        this.formalParam = formalParamVisitor.getTypes();
    }
    
    public Type getClassType() throws CompilerException{
        List<Type> params = new ArrayList<>();
        if (typeVisitor != null) {
            params.add(typeVisitor.getType());
        } else {
            params.add(new Type.ClassType(null, "java/lang/Void", null));
        }
        params.addAll(this.formalParam);
        return new Type.ClassType(null, "teajay/lang/Closure",params );
    }
}
