/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.VariableDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFieldDeclaratorsRestVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import teajay.bytecode.fields.FieldInfo;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3FieldDeclaratorsRestVisitor extends AbstractFieldDeclaratorsRestVisitor {
    private final Stage3Environment stage3Env;
    private final String fieldName;
    private final Type type;

    public Stage3FieldDeclaratorsRestVisitor(Stage3Environment stage3Env,
                                    String fieldName,Type type) {
        this.stage3Env = stage3Env;
        this.fieldName = fieldName;
        this.type = type;
    }

    

    @Override
    public void begin(VariableDeclaratorRestNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(VariableDeclaratorRestNode node) throws CompilerException {
        FieldInfo field = this.stage3Env.getClassFile().getField(fieldName);
        if(field.isStatic()){
            //Visit with static constructor field builder
            return new Stage3VariableDeclaratorRestVisitor(stage3Env,fieldName,stage3Env.getStaticConstructorFieldInitBuilder(),type);
        }else{
            //Visit with constructor field builder
            return new Stage3VariableDeclaratorRestVisitor(stage3Env,fieldName,stage3Env.getConstructorFieldInitBuilder(),type);
        }
    }

    @Override
    public void end(VariableDeclaratorRestNode node) throws CompilerException {
        
    }
    
}
