/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.FieldDeclaratorsRestNode;
import abstractsyntaxtree.MethodeDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMethodeOrFieldRestVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import stage3.states.MethodState;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3MethodOrFieldRestVisitor extends AbstractMethodeOrFieldRestVisitor {
    private final Stage3Environment stage3Env;
    private final String methodOrFieldName;
    private final Type type;
    private boolean isField = false;

    public Stage3MethodOrFieldRestVisitor(Stage3Environment stage3Env, 
            String methodOrFieldName, Type type) {
        this.stage3Env = stage3Env;
        this.methodOrFieldName = methodOrFieldName;
        this.type = type;
    }

    

    @Override
    public void begin(FieldDeclaratorsRestNode node) throws CompilerException {
        this.isField = true;
    }

    @Override
    public void begin(MethodeDeclaratorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(FieldDeclaratorsRestNode node) throws CompilerException {
        return new Stage3FieldDeclaratorsRestVisitor(stage3Env,this.methodOrFieldName,type);
    }

    @Override
    public Visitor visit(MethodeDeclaratorRestNode node) throws CompilerException {
        stage3Env.initState(new MethodState());
        stage3Env.setCurrentMethodExpectedType(this.type);
        System.out.println(" ||   "+stage3Env.getClassFile().getThis().getClassName() +"::"+methodOrFieldName +"   ||");
        return new Stage3MethodDeclaratorRestVisitor(stage3Env, methodOrFieldName, type);
    }

    @Override
    public void end(FieldDeclaratorsRestNode node) throws CompilerException {

    }

    @Override
    public void end(MethodeDeclaratorRestNode node) throws CompilerException {

    }

    public boolean isFieldDeclaration() {
        return this.isField;
    }
    
}
