/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.TypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeArgumentsOrDiamondVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3TypeArgumentsOrDiamondVisitor extends AbstractTypeArgumentsOrDiamondVisitor {
    private final Stage3Environment stage3Env;
    private Stage3TypeArgumentsVisitor typeArguments;

    public Stage3TypeArgumentsOrDiamondVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(TypeArgumentsNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeArgumentsNode node) throws CompilerException {
        return this.typeArguments = new Stage3TypeArgumentsVisitor(stage3Env);
    }

    @Override
    public void end(TypeArgumentsNode node) throws CompilerException {
        
    }

    public List<Type> getTypeParams() {
        return this.typeArguments.getTypes();
    }

    
    
}
