/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.VariableInitializerNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVariableDeclaratorRestVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import stage3.utils.FieldInitBuilder;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3VariableDeclaratorRestVisitor extends AbstractVariableDeclaratorRestVisitor {
    private final Stage3Environment stage3Env;
    private final String varName;
    private final FieldInitBuilder fieldBuilder;
    private final Type type;
    private boolean hasInit = false;

    public Stage3VariableDeclaratorRestVisitor(Stage3Environment stage3Env, 
                    String fieldName, FieldInitBuilder fieldBuilder,Type type) {
        this.stage3Env = stage3Env;
        this.varName = fieldName;
        this.fieldBuilder = fieldBuilder;
        this.type = type;
    }

    Stage3VariableDeclaratorRestVisitor(Stage3Environment stage3Env, String name, Type type) {
        this.stage3Env = stage3Env;
        this.varName = name;
        this.type = type;
        this.fieldBuilder = null;

    }

    @Override
    public void begin(VariableInitializerNode node) throws CompilerException {
        hasInit = true;
    }

    @Override
    public Visitor visit(VariableInitializerNode node) throws CompilerException {
        return new Stage3VariableInitializerVisitor(stage3Env,varName,fieldBuilder,type );
    }

    @Override
    public void end(VariableInitializerNode node) throws CompilerException {

    }
    /**
     * @description check is statement: Type a = exp ;
     * @return false, if statement: Type a; true, if statement Type a = exp;
     */
    public boolean hasInit(){
        return this.hasInit;
    }
    
}
