/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.VariableDeclaratorNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVariableDeclaratorsVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import symbol.LocalEntry;
import teajay.bytecode.attributes.code.AConstNull;
import teajay.bytecode.attributes.code.AStore;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3VariableDeclaratorsVisitor extends AbstractVariableDeclaratorsVisitor {

    private final Stage3Environment stage3Env;
    private final Type type;

    public Stage3VariableDeclaratorsVisitor(Stage3Environment stage3Env, Type type) {
        this.stage3Env = stage3Env;
        this.type = type;

    }

    @Override
    public void begin(VariableDeclaratorNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(VariableDeclaratorNode node) throws CompilerException {
        return new Stage3VariableDeclaratorVisitor(stage3Env, type, node.getName());
    }

    @Override
    public void end(VariableDeclaratorNode node) throws CompilerException {
       
    }
}
