/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.states;

import abstractsyntaxtree.SyntaxNode;
import exceptions.CompilerException;
import java.util.Deque;

/**
 *
 * @author Michael Burzan
 */
public class ConstructorState extends AbstractState {
    private boolean hasSuper = false;
    
    public ConstructorState(){
       super();
       
     
    }
    
    public boolean hasSuper(){
        return hasSuper;
    }
    
    @Override
    public State changeState(BlockState state,SyntaxNode node)throws CompilerException{
        state.parent = this;
        return state;
    }
    
    public State changeState(StatementExpressionState state, SyntaxNode node)throws CompilerException{
        state.parent = this;
        if(state.isSuper() && hasSuper ){
            throw new CompilerException("duplicate call to super", node.getSymbol());
        }
        return state;
    }
    
    public State changeState(WhileState state, SyntaxNode node)throws CompilerException{
        state.parent = this;
        return state;
    }
    
    public State changeState(IfState state,SyntaxNode node) throws CompilerException{
        state.parent = this;
        return state;
    }
    
    
    public State changeState(LocalVariableDeclarationState state,SyntaxNode node) throws CompilerException{
        state.parent = this;
        return state;
    }
    
    public State changeState(ReturnState state,SyntaxNode node) throws CompilerException{
        throw new CompilerException("Return statement not allowed in constructor", node.getSymbol());
    }
    
    public void setHasSuper(){
        this.hasSuper = true;
    }
    
    
    


}
