/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.states;

import abstractsyntaxtree.SyntaxNode;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class UnreachableCodeState extends EndState {

    @Override
    public State changeState(ConstructorState newState, SyntaxNode node) throws CompilerException {
        throw new Error("FatalError:UnreachableCodeState will be change to constructor state");
    }

    @Override
    public State changeState(VoidMethodState newState, SyntaxNode node) throws CompilerException {
        throw new Error("FatalError:UnreachableCodeState will be change to void method state");
    }

    @Override
    public State changeState(AssertState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(BlockState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(DoState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(IdentDoublePointState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(IfState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(StatementExpressionState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(WhileState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(ForState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(BreakState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(ContinueState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(ReturnState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(ThrowState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(SynchronizedState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(TryState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(TypeSwitchState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(LocalVariableDeclarationState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State changeState(MethodState state, SyntaxNode node) throws CompilerException {
        throw new CompilerException("Unreachable code detected", node.getSymbol());
    }

    @Override
    public State getParent() {
        return super.getParent(); //To change body of generated methods, choose Tools | Templates.
    }
}
