/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.lang;

import teajay.util.TJType;
import teajay.util.tjattribute.TeaJayAttribute;

/**
 * TeaJay's iterator.
 * @author Michael Kußmann <michi@outx.de>
 */
@TJType(type = TeaJayAttribute.Type.Interface)
public interface TJIterator<T> {
    /**
     * After a finite count of invocations this method has to return false!
     * @return true if and only if the next call to {@code next()} won't throw an {@code IllegalStateException}
     */
    Boolean hasNext();
    /**
     * the next element
     * @return the next element in this collection
     * @throws IllegalStateException if there is no next element
     */
    T next() throws IllegalStateException;
    /**
     * May always throw an #UnsupportedOperationException.
     */
    void remove();
}
