/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.lang.java;

import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.*;
import teajay.lang.Closure;
import teajay.util.TJSignature;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class DrawCanvas extends JComponent {

    private final Closure c;

    @TJSignature("(Lteajay/lang/Closure<Ljava/lang/Void;Ljava/awt/Graphics2D;>;)V")
    public DrawCanvas(Closure c) {
        this.c = c;
    }

    @Override
    public void paint(Graphics g) {
        try {
            c.execute((Graphics2D) g);
        } catch (Throwable ex) {
            Thread.currentThread().getUncaughtExceptionHandler().uncaughtException(Thread.currentThread(), ex);
        }
    }
}
